import { proxyCustomElement, HTMLElement, h } from '@stencil/core/internal/client';
import { c as create$3, a as create$6, F as FormController } from './form.js';
import { D as DisputeResponseFormStep, f as fileInputHandler } from './file-input-handler.js';
import { a2 as heading5 } from './parts.js';
import { d as defineCustomElement$6 } from './custom-popper2.js';
import { d as defineCustomElement$5 } from './form-control-file-v22.js';
import { d as defineCustomElement$4 } from './form-control-help-text3.js';
import { d as defineCustomElement$3 } from './form-control-text2.js';
import { d as defineCustomElement$2 } from './form-control-textarea2.js';
import { d as defineCustomElement$1 } from './form-control-tooltip2.js';

const DuplicateChargeSchema = create$3({
    duplicate_charge_original_payment_id: create$6().nullable(),
    duplicate_charge_explanation: create$6().nullable(),
});

const DuplicateCharge = /*@__PURE__*/ proxyCustomElement(class DuplicateCharge extends HTMLElement {
    constructor(registerHost) {
        super();
        if (registerHost !== false) {
            this.__registerHost();
        }
        this.documentErrors = {};
        this.errors = {};
        this.documents = { duplicate_charge_documentation: [] };
        this.inputHandler = (name, value) => {
            this.form.setValues(Object.assign(Object.assign({}, this.form.values.getValue()), { [name]: value }));
        };
    }
    async validateAndSubmit(onSuccess) {
        const documentList = Object.values(this.documents).flat();
        this.form.validateAndSubmit((formData) => onSuccess(formData, documentList, DisputeResponseFormStep.duplicateCharge));
    }
    ;
    componentWillLoad() {
        this.form = new FormController(DuplicateChargeSchema);
    }
    componentDidLoad() {
        this.form.errors.subscribe(errors => {
            this.errors = Object.assign({}, errors);
        });
    }
    render() {
        var _a, _b, _c;
        return (h("div", { key: 'ec4cfa15f2830ec56dfd9184728c1badeb9e1dfd' }, h("div", { key: '0e107461e759478735aecabea93baf060169dd14', class: "row gy-3" }, h("div", { key: '22b9223c3e92d2183d65d9125a3ebefd341c140f', class: "col-12" }, h("h2", { key: 'cf386e687b18a4f232b935a847270d8ad463db32', class: "h5", part: heading5 }, "Duplicate Charge")), h("div", { key: 'dd8cc52b7b6cfe955a09e29c145f70761db87068', class: "col-12" }, h("form-control-text", { key: 'ff024fd4e90adc3a991036eb535258bad98ab199', label: "Original Payment ID", name: "duplicate_charge_original_payment_id", defaultValue: (_a = this.disputeResponse) === null || _a === void 0 ? void 0 : _a.duplicate_charge_original_payment_id, inputHandler: this.inputHandler, errorText: this.errors.duplicate_charge_original_payment_id })), h("div", { key: '0df77b3c8d8a8a777c8258cd0ca075df73552ee4', class: "col-12" }, h("form-control-textarea", { key: '27bfe00c3bdab393b35f3ca26360db65f487d789', label: "Duplicate Charge Explanation", name: "duplicate_charge_explanation", defaultValue: (_b = this.disputeResponse) === null || _b === void 0 ? void 0 : _b.duplicate_charge_explanation, inputHandler: this.inputHandler, errorText: this.errors.duplicate_charge_explanation })), h("div", { key: '8420318e367111cb73c1235c363973d7f34aa25c', class: "col-12" }, h("form-control-file-v2", { key: '71717a0c8d02e2c8198b365f61b1a6727a619e6b', label: "Duplicate Charge Documentation", name: "duplicate_charge_documentation", onChange: (e) => fileInputHandler(e, this.documents), errorText: (_c = this.documentErrors) === null || _c === void 0 ? void 0 : _c.duplicate_charge_documentation })))));
    }
}, [256, "duplicate-charge", {
        "disputeResponse": [8, "dispute-response"],
        "documentErrors": [8, "document-errors"],
        "form": [32],
        "errors": [32],
        "documents": [32],
        "validateAndSubmit": [64]
    }]);
function defineCustomElement() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["duplicate-charge", "custom-popper", "form-control-file-v2", "form-control-help-text", "form-control-text", "form-control-textarea", "form-control-tooltip"];
    components.forEach(tagName => { switch (tagName) {
        case "duplicate-charge":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, DuplicateCharge);
            }
            break;
        case "custom-popper":
            if (!customElements.get(tagName)) {
                defineCustomElement$6();
            }
            break;
        case "form-control-file-v2":
            if (!customElements.get(tagName)) {
                defineCustomElement$5();
            }
            break;
        case "form-control-help-text":
            if (!customElements.get(tagName)) {
                defineCustomElement$4();
            }
            break;
        case "form-control-text":
            if (!customElements.get(tagName)) {
                defineCustomElement$3();
            }
            break;
        case "form-control-textarea":
            if (!customElements.get(tagName)) {
                defineCustomElement$2();
            }
            break;
        case "form-control-tooltip":
            if (!customElements.get(tagName)) {
                defineCustomElement$1();
            }
            break;
    } });
}
defineCustomElement();

export { DuplicateCharge as D, defineCustomElement as d };
